clear

format longg

cd 'G:\Public Economics\Forschung\GRW Projekt\Revision 2 JIE\matlab';
path='G:\Public Economics\Forschung\GRW Projekt\Revision 2 JIE\matlab';
%cd 'F:\Projekte\GRW Projekt\Paper\BlouriEhrlich2017\ModelSol3without1000';
%path='F:\Projekte\GRW Projekt\Paper\BlouriEhrlich2017\ModelSol3without1000';

SETSAMPLE='Full' %'Full', 'AT' or 'AT_DE' 'mu025'

if strcmp(SETSAMPLE, 'Full')==1
    load([path '\output\mat\Results_2013_KAPPA1.mat']);
end
if strcmp(SETSAMPLE, 'AT')==1
    load([path '\output\mat\Results_2013_KAPPA1_Reg9AT.mat']);
end
if strcmp(SETSAMPLE, 'AT_DE')==1
    load([path '\output\mat\Results_2013_KAPPA1_Reg48ATDE.mat']);
end
if strcmp(SETSAMPLE, 'mu025')==1
    load([path '\output\mat\Results_2013_KAPPA1_mu025.mat']);
end
addpath([path '\functions\']);
path='G:\Public Economics\Forschung\GRW Projekt\Revision 2 JIE\matlab';
%path='F:\Projekte\GRW Projekt\Paper\BlouriEhrlich2017\ModelSol3without1000';

rng(2438894) 
%!!!!!!!!!!!!!!!!!
%Update Transfer shares according to Transfer Types
PARA.TS0=PARA.TSd0;
PARA.TBAR=PARA.TBARd;
%!!!!!!!!!!!!!!!!!

PARA_out
PARA.WBAR=1e6;

for i=5:1:10

SETGUESS='Random' %'Optimal', 'Random' or 'Actual'

if strcmp(SETGUESS, 'Optimal')==1
    %[dataimport,dataimport2] = xlsread(['G:\Public Economics\Forschung\GRW Projekt\Paper\BlouriEhrlich2017\ModelSol3\output\xls\output.xlsx'],'Opt Trans a t4');
    [dataimport,dataimport2] = xlsread([path '\output\xls\output.xlsx'],'Opt Trans a t4');
    GUESS_TS=dataimport(:,3);
	TS1 = GUESS_TS./sum(GUESS_TS);
    PARA.TS1=GUESS_TS;
end
if strcmp(SETGUESS, 'Random')==1
    pd = makedist('Normal',0,1e90);
    TS1=random(pd,n,1);
    TS1=abs(TS1);
    TS1 = TS1./sum(TS1);
    PARA.TS1=TS1;
end
if strcmp(SETGUESS, 'Actual')==1
    TS1 = PARA.TS0;
    PARA.TS1=PARA.TS0;
end
if strcmp(SETGUESS, 'Equal')==1
    TS1 = PARA.lambda0;
    PARA.TS1=PARA.lambda0;
end
if strcmp(SETGUESS, 'All')==1
    TS1 = zeros(n,1);
    TS1(round(rand*(n-1)+1),1)=1;
    PARA.TS1=TS1;
end
%
% Similar Tax rates
%
PARA.t1=(PARA.TBAR./(sum(PARA.w0.*PARA.lambda0.*PARA.LBAR))).*ones(n,1);

[Utility_ch,PARA]=solveCounterfactual_d(PARA);
PARA.scaling
TBAR=sum(PARA.w_ch.*PARA.w0.*PARA.L_ch.*PARA.L0.*PARA.t1);

PARA.lambda1=PARA.lambda_ch.*PARA.lambda0;
PARA.L1=PARA.L_ch.*PARA.L0;
PARA.w1=PARA.w_ch.*PARA.w0;
PARA.v1=PARA.v_ch.*PARA.v0;
PARA.pi1=PARA.pi_ch.*PARA.pi0;

housingExp=(1-alpha)*PARA.v1.*PARA.lambda1.*PARA.LBAR;
PARA.chi=(sum(iota.*housingExp))./PARA.LBAR;

%othersolvingmethod_fmincon
options_knitro

%
% Form GUESS - NEW - Reduced d - Infra
%
GUESS=[];
GUESS(1:1*n,1) = PARA.lambda_ch.*PARA.lambda0; 
GUESS(1*n+1:2*n,1) = PARA.w_ch.*PARA.w0;
GUESS(2*n+1:3*n,1) = diag(PARA.pi_ch).*diag(PARA.pi0);
GUESS(3*n+1:4*n,1) = TS1; %ones(n,1); %TS_ch
GUESS(4*n+1,1) =  Utility_ch(1);
GUESS(4*n+2,1) =  PARA.TBAR_ch;

addpath(genpath([path '\functions\ADMAT-2.0']));
%run([path '\functions\ADMAT-2.0\startup.p'])

PARA.opimization='Transport';
PARA.StableVariance='No'; % 'YesNomIncome' or 'No'

meanVARIABLE=(1./PARA.n).*sum(sum(v0.*PARA.v_ch));
PARA.StableVarianceVal = ((1./(PARA.n-1)).*sum(sum((v0.*PARA.v_ch-meanVARIABLE).^2))).^(0.5)./meanVARIABLE;
PARA.StableVarianceVal

max(abs(cons_eq(GUESS,PARA)))

[x,fval,exitflag,output] = knitromatlab(@(x)func(x, PARA), GUESS, [], [], [], [], lb, ub, @(x)optcons(x, PARA), extendedFeatures, options);

if strcmp(PARA.StableVariance, 'YesNomIncome')==1 
    save([path '\output\mat\temp_d.mat'])
    load([path '\output\mat\temp_d.mat'])

    cons_eq(x,PARA)

    cons_eq(GUESS,PARA)

    asdf
    
    PARA.scalingOpt='No';
    meanVARIABLE2=(1./PARA.n).*sum(sum(PARA.v0.*PARA.v_ch));
    [PARA.StableVarianceVal, ((1./(PARA.n-1)).*sum(sum((PARA.v0.*PARA.v_ch-meanVARIABLE).^2))).^(0.5)./meanVARIABLE2]
    (PARA.StableVarianceVal/(((1./(PARA.n-1)).*sum(sum((PARA.v0.*PARA.v_ch-meanVARIABLE).^2))).^(0.5)./meanVARIABLE2)-1)*100
    
    SETGUESS=[SETGUESS ' stVar']

end

PARA.TS1BACK=PARA.TS1;
PARA.TS1=x(3*n+1:4*n,1);
PARA.TS1 = PARA.TS1./sum(PARA.TS1);
[Utility_ch,PARA]=solveCounterfactual_d(PARA);
Utility_ch(1)

PARA.TS1_B=PARA.TS1;
PARA.TS1_B(PARA.TS1.*PARA.TBAR_ch.*PARA.TBAR<1000)=NaN;

T = table(PARA.regions,PARA.id_0, Utility_ch, PARA.TS1, PARA.TS1_B, PARA.TS1BACK,output.constrviolation.*ones(n,1), output.iterations.*ones(n,1));
T.Properties.VariableNames = {'Region' 'RegionID' 'U1' 'TS1' 'TS1_B' 'TS1GUESS' 'FEAS' 'ITER' };
filename = [path '\output\xls\output_d1.xlsx'];
system('taskkill /F /IM EXCEL.EXE');
writetable(T,filename,'Sheet',['Opt Trans d t'  num2str(i) ' ' SETGUESS])

end

